Attribute VB_Name = "Serial_Interface"
Global Gport As Byte

Function check_comports()      ' test which comports are present
Dim low_port As Byte
Dim port As Byte

On Error GoTo nocom

With Form1
low_port = 0

For port = 1 To 8
  .MsComm1.CommPort = port
  .MsComm1.PortOpen = True
  If (low_port = 0 And .MsComm1.PortOpen = True) Then
      low_port = port
  End If
  .MsComm1.PortOpen = False
Next
check_comports = low_port
Exit Function

nocom:
    .setCOM(port).Enabled = False
Resume Next

End With
End Function

Private Sub uncheck_comports()
Dim i As Byte
 With Form1
 For i = 1 To 8
 .setCOM(i).Checked = False
 Next i
 End With
End Sub

Sub set_Com(port As Byte)
 With Form1
 If .MsComm1.PortOpen = True Then
    .MsComm1.PortOpen = False
 End If
 
 uncheck_comports
 
 .MsComm1.CommPort = port
 .MsComm1.Settings = "9600,n,8,1"
 .MsComm1.InputMode = comInputModeBinary
 .MsComm1.RThreshold = 1
 .MsComm1.SThreshold = 1
 .MsComm1.PortOpen = True
 
 .setCOM(port).Checked = True
 End With
Gport = port
End Sub

Sub init_comport()
Dim curr_port As Byte
Dim i As Byte

With Form1

For i = 1 To 8
.setCOM(i).Enabled = True
Next i

curr_port = check_comports()


If (.setCOM(Gport).Enabled = True) Then
  set_Com (Gport)                     ' use last port if still available
Else
  set_Com (curr_port)                 ' else use lowest port available
End If
End With
End Sub
